require "GetTaoBaoProduct/version"

module GetTaoBaoProduct
  class Item
    def get_info url
      return 'product_url_nil' if url.nil?

      doc = Nokogiri::HTML(open(url))
      doc.encoding = 'utf-8'

      begin
        title = doc.css('.tb-detail-hd').first.text
      rescue NoMethodError
        return 'product_not_exists'
      end

      title = title_fiter(title.strip)

      if url.include? 'taobao'     #淘宝
        price = doc.css('em.tb-rmb-num').first.text
        img = doc.css('#J_ImgBooth').first.attr('data-src')
      elsif url.include? 'tmall'   #天猫
        price = doc.css('.J_originalPrice').first.text.strip
        img = doc.css('#J_ImgBooth').first.attr('src')
      else
        return 'product_url_is_not_taobao'
      end

      {
        title: title,
        price: price,
        img: img,
        url: url
      }
    end

    private
    def title_fiter(title)
      title = title.split("\r\n")[0]

      filter_char = ["\n","\r","\t",' ']
      filter_char.each do |s|
        title = title.gsub(s,'')
      end

      title
    end
  end
end
